import java.util.Arrays;

public class MyArrayList<E> {

    private E[] array;

    public MyArrayList()
    {
        this.array = (E[]) new Object();
    }

    public MyArrayList(int size)
    {
        this.array = (E[]) new Object[size];
        //MyArrayList = (E[]) new Object[initSize];
    }

    public int size()
    {
        return array.length;
    }

    public void  add(int index,E e)
    {
        if(array.length < index)
        {
            array[index] = e;
        }
        else
        {
            E[] myNewArray =Arrays.copyOf(this.array,index+1); //clear
            myNewArray[index] = e;
            this.array = myNewArray;     // pointer pointing to new array
        }

    }

    public void add(E e)
    {
        E[] myArrayNew = Arrays.copyOf(this.array,this.array.length+1);
        myArrayNew[this.array.length - 1] = e;
        this.array = myArrayNew;
    }
    public E get(int index)
    {
        return this.array[index];
    }



    public void Remove(int index)
    {
        E[] myArrayNew = Arrays.copyOf(this.array,this.array.length-1);
        for(int i = 0;i < index;i++)    //copying the elements from one array to next till index;excluding index
        {
            myArrayNew[i] =array[i];
        }
        for(int i = index + 1;i < myArrayNew.length;i++ )
        {
            myArrayNew[i] = array[i];
        }

    }

    public E[] clear()
    {
        E[] myClearedArray = Arrays.copyOf(this.array,0);
        return myClearedArray;

    }
    public void setArray(int index, E e)
    {
         array[index] = e;
    }
    public boolean isEmpty()
    {
        for(int i =0;i < array.length;i++)
        {
            if(array[i] == null)
            {
                return true;
            }
        }
        return false;
    }
    public boolean contains(E e)
    {
        for(int i =0 ;i < array.length;i++)
        {
            if(array[i] == e)
            {
                return true;
            }
        }
        return false;
    }
}
